using UnityEngine;
using UnityEngine.UI;
using TMPro;
using BackEnd;

public class RegisterAccount : LoginBase
{
	[SerializeField]
	private	Image			imageID;				// ID ʵ  
	[SerializeField]
	private	TMP_InputField	inputFieldID;			// ID ʵ ؽƮ  
	[SerializeField]
	private	Image			imagePW;				// PW ʵ  
	[SerializeField]
	private	TMP_InputField	inputFieldPW;			// PW ʵ ؽƮ  
	[SerializeField]
	private	Image			imageConfirmPW;			// Confirm PW ʵ  
	[SerializeField]
	private	TMP_InputField	inputFieldConfirmPW;	// Confirm PW ʵ ؽƮ  
	[SerializeField]
	private	Image			imageEmail;				// Email ʵ  
	[SerializeField]
	private	TMP_InputField	inputFieldEmail;		// Email ʵ ؽƮ  

	[SerializeField]
	private	Button			btnRegisterAccount;		// " " ư (ȣۿ /Ұ)

	/// <summary>
	/// " " ư   ȣ
	/// </summary>
	public void OnClickRegisterAccount()
	{
		// Ű Է InputField UI  Message  ʱȭ
		ResetUI(imageID, imagePW, imageConfirmPW, imageEmail);

		// ʵ  ִ üũ
		if ( IsFieldDataEmpty(imageID, inputFieldID.text, "̵") )						return;
		if ( IsFieldDataEmpty(imagePW, inputFieldPW.text, "йȣ") )						return;
		if ( IsFieldDataEmpty(imageConfirmPW, inputFieldConfirmPW.text, "йȣ Ȯ") )	return;
		if ( IsFieldDataEmpty(imageEmail, inputFieldEmail.text, " ּ") )				return;

		// йȣ йȣ Ȯ  ٸ 
		if ( !inputFieldPW.text.Equals(inputFieldConfirmPW.text) )
		{
			GuideForIncorrectlyEnteredData(imageConfirmPW, "йȣ ġ ʽϴ.");
			return;
		}

		//   ˻
		if ( !inputFieldEmail.text.Contains("@") )
		{
			GuideForIncorrectlyEnteredData(imageEmail, "  ߸Ǿϴ. (ex. address@xx.xx)");
			return;
		}

		//   ư ȣۿ Ȱȭ
		btnRegisterAccount.interactable = false;
		SetMessage(" Դϴ..");

		// ڳ    õ
		CustomSignUp();
	}

	/// <summary>
	///   õ  κ ޹ message   ó
	/// </summary>
	private void CustomSignUp()
	{
		Backend.BMember.CustomSignUp(inputFieldID.text, inputFieldPW.text, callback =>
		{
			// " " ư ȣۿ Ȱȭ
			btnRegisterAccount.interactable = true;

			//   
			if ( callback.IsSuccess() )
			{
				// E-mail  Ʈ
				Backend.BMember.UpdateCustomEmail(inputFieldEmail.text, callback =>
				{
					if ( callback.IsSuccess() )
					{
						SetMessage($"  . {inputFieldID.text} ȯմϴ.");

						//     ش    
						BackendGameData.Instance.GameDataInsert();

						//  Ʈ  ҷ
						BackendChartData.LoadAllChart();

						// Lobby  ̵
						Utils.LoadScene(SceneNames.Lobby);
					}
				});
			}
			//   
			else
			{
				string message = string.Empty;

				switch ( int.Parse(callback.GetStatusCode()) )
				{
					case 409:	// ߺ customId ϴ 
						message = "̹ ϴ ̵Դϴ.";
						break;
					case 403:	// ܴ ̽ 
					case 401:	// Ʈ ° '' 
					case 400:	// ̽  null 
					default:
						message = callback.GetMessage();
						break;
				}

				if ( message.Contains("̵") )
				{
					GuideForIncorrectlyEnteredData(imageID, message);
				}
				else
				{
					SetMessage(message);
				}
			}
		});
	}
}

